# Letter to Future Pelias Intern

### Authors:
![](https://avatars0.githubusercontent.com/u/13492525?v=4&s=40) [Lily He](https://github.com/tigerlily-he)

#

To future Pelias intern,

Congratulations and welcome to the Pelias team! You are about to embark on a magnificient journey. Since you're working on the geocoder, you can go anywhere you want. (As of August 2017, there are 1 billion addresses, streets, venues, and admin areas in Pelias.) Here are some things you should know about Mapzen, Pelias, geography, and tech that Pelias runs on.

# Mapzen
There are 6 teams at Mapzen dispersed in NYC, San Francisco, Lancaster, and around the world.  
* Pelias
* Tangram (Graphics and Tiles)
* Mobility (Routing and Transitland)
* Data (Who's on First)
* Product/Biz Dev
* Mobile (Android & iOS)

# Pelias
These are the people that the Pelias team comprises of. 

Name | Location | Ask them about
--- | --- | ---
Diana | Philly (NYC 1/week) | Refactoring, team building, 
Julian | NYC | AWS, Kubernetes
Stephen | Wilmington, DE (NYC biweekly) | Lodash, unit tests
Peter | Berlin | Speeding up builds, interpolation

# Setting up your computer
Some recommendedations for your environment. This is up to personal preference
## OSX
* Zsh
* iTerm2
* Homebrew

## Linux

## Non Operating system Specific
* Git
* [Add SSH Key to Github](https://help.github.com/articles/generating-a-new-ssh-key-and-adding-it-to-the-ssh-agent/)
* [Git config dot file](https://github.com/orangejulius/dotfiles/blob/master/gitconfig)
* Text Editor: Atom, Sublime Text, Webstorm, vim, or emacs

# Your First Task
Install a [local instance](http://pelias.io/install.html) of Pelias. Keep notes as you go through the steps. Any questions or confusions you have will be the same questions new Pelias users have. 

# Your First Pull Request
Add you Github handle and link to the list of current contributors in the pelias/pelias repo.

# General Advice
* Ask how-to questions, how-does-this-work questions, why-do-we-do-this questions. 
* Ask to clarify acronyms and jargon
* If you're stuck on the same thing for 20 minutes without any progress, speak up. Ping the whole search slack channel or a specific person. 
* Ask to pair program and chat online or in person if you'd like support
* Think about what types of tasks you like to do: writing new stuff, debugging, refactoring, testing
* Think about what area of the project interests you for future tasks - check out issues tagged "low hanging fruit" or "help wanted"
* Get to know people outside of Pelias - everyone at Mapzen is interesting!
* Favor making things **right** over hacking things fast

# Recommended Reading
Here are some blogs, tutorials, and wikis for background on what Pelias does and guidelines to help write better code.

## Geo
* [Mapzen Blog: Meaningful Geocoding - Geocoding Places](https://mapzen.com/blog/geocoding-places/)
* [Mapzen Blog: Meaningful Geocoding - Address Search & The Two Core Principles of Geocoding](https://mapzen.com/blog/meaningful-geocoding-address-search-the-two-core-principles-of-geocoding/)
* [Mapzen Blog: Do Less Get More](https://mapzen.com/blog/structured-geocoding/)
* [Mapzen Blog: Inside Libpostal](https://mapzen.com/blog/inside-libpostal/)
* [Mapzen Blog: Street Address Interpolation](https://mapzen.com/blog/interpolation/)
* [Mapzen Blog: Avoiding the Total Perspective Vortex](https://mapzen.com/blog/total-perspective-vortex/)
* [Mapzen Blog: Who's on First](https://mapzen.com/blog/who-s-on-first/)
* [More than you ever wanted to know about GeoJSON](https://macwright.org/2015/03/23/geojson-second-bite.html)
* [Falsehoods Programmers Believe About Addresses](https://www.mjt.me.uk/posts/falsehoods-programmers-believe-about-addresses/)
* [Click that Hood Game](http://click-that-hood.com/north-america)

## Tech
* [JavaScript Koans](https://github.com/liammclennan/JavaScript-Koans)
* [ECMAScript 6 Tutorial](http://es6-features.org/)
* [AirBnB JavaScript Styleguide](https://github.com/airbnb/javascript)
* [Guide to Writing Solid Tests](https://github.com/pelias/acceptance-tests/wiki/Guide-to-writing-solid-tests)
* [Acceptance Tests Measuring Change](https://github.com/pelias/pelias/wiki/Acceptance-Tests---Measuring-Change)
* [Code Review Checklist](https://github.com/chef/chef-server/blob/master/CODE_REVIEW_CHECKLIST.md)
* [Rebase v. Merging](https://www.atlassian.com/git/tutorials/merging-vs-rebasing)
* [Express.js - Hello World](https://expressjs.com/en/starter/hello-world.html)
* [How to Write Middleware for Express.js Apps](https://stormpath.com/blog/how-to-write-middleware-for-express-apps)
* [Learn Ruby with Edgecase Ruby Koans](http://rubykoans.com/)
* [Rosetta Code](http://rosettacode.org/wiki/Rosetta_Code#Places_to_startx)
* [Callback Hell](http://callbackhell.com/)
* [Docker Get Started](https://docs.docker.com/get-started/)
* [Docker for Developers Classroom](http://training.play-with-docker.com/dev-landing/)
* [Docker vs. Kubernetes vs. Apache Mesos](https://mesosphere.com/blog/docker-vs-kubernetes-vs-apache-mesos/)

## Bookmarks
* [Pelias Compare App](http://pelias.github.io/compare/#/v1/search%3Ftext=)
* [Mapzen Search Documentation](https://mapzen.com/documentation/search/)
* [Github Open Pelias PRs](https://github.com/pulls?utf8=%E2%9C%93&q=is%3Aopen+is%3Apr+user%3Apelias+)
* [Lodash Documentation](https://lodash.com/docs/)
* [Who's on First Spelunker](https://whosonfirst.mapzen.com/spelunker/)
* [Pelias Standup Google Hangouts](https://hangouts.google.com/hangouts/_/mapzen.com/pelias-flow-up?authuser=0)
* [Sense Chrome Extension](https://chrome.google.com/webstore/detail/sense-beta/lhjgkmllcaadmopgmanpapmpjgmfcfig?hl=en)
