# Community Building

[Track Milestone Here](https://github.com/issues?utf8=%E2%9C%93&q=is%3Aopen+user%3Apelias+milestone%3A%22Community+Building%22)


## Overview

We are trying to establish an identity for Pelias, the open source project, that is distinct from Mapzen Search.
This is the first and necessary step in forming a community around this project. In addition to that work, we also
need to commit to more public-facing events, such as workshops, meetups, and office hours.
We should also do our best to continue being responsive to github issues that come in from the community.


## External Dependencies

Just the people we are trying to attract to our community of contributors.


## Functionality

- [ ] Host a landing page for the project with all the details needed for someone to understand what it is and how they can use it and/or get involved. The site should at a minimum contain the following information.
    - Links to github, waffle, gitter chat room, npm?, twitter?
    - General overview documentation about what geocoding is and how it works.
    - Current quarterly goals with detailed proposals for each one.
- [ ] Commit to hosting a single workshop dedicated to the use of Mapzen Search or Pelias. This can be on either coast.
- [ ] Attempt to highligh a single external project for the work they do with Pelias or Mapzen Search. This could be in the form of a blog post, demo, video, workshop, etc.
- [ ] Commit to replying to all incoming github issues within 48 hours. This means a reply that at the very least says thanks and we're on it. This might be accomplished via a slackbot that will notify the team daily about unanswered issues.

## Operations

- [x] Register `pelias.io` domain
- [ ] Make the slackbot. :robot:
- [ ] Deploy pelias.io docs site
- [ ] Setup automated updates to pelias.io every time pelias/pelias repo is updated with documentation


## Future Work

This is an ongoing effort so there is too much future work to mention it all here. If anyone in the community has ideas 
on how we could be doing this better, please comment and/or submit github issues with ideas!
