# Quarterly Goals (Q4 2016)

## Features

### [Alt-Names](/milestones/alt_names/)

Add all available alternate names for places to the search index and all queries to search 
across all those names. This would allow users to search for the same place in many languages, 
which gets us a step closer towards internationalization.

### [~~Component Geocoding~~](/milestones/component_geocoding/)

>_Note: this milestone is a carry-over from Q3-2016_

Add support for address search where the five traditional parts of an address are specified independently, instead of the current single “text” input parameter. Currently users are forced to concatenate the address parts into a single string, often resulting in formatting issues and encoding errors.

### [Coarse Reverse geocoding](/milestones/coarse_reverse/)

>_Note: this milestone is a carry-over from Q3-2016_

The current implementation of coarse reverse geocoding is problematic and often returns incorrect results. 
We will switch over to a true point-in-polygon solution when the query specifies the “coarse” alias or any 
of the administrative layers in the filters.

### [Add Postcodes](https://github.com/pelias/pelias/milestone/30)

>_Note: this milestone is a carry-over from Q3-2016_

Postal codes will be added to the Elasticsearch index as a new layer. Searching for a specific postal code will return the appropriate record. Postal code records will be represented by reasonable centroids. Geometries will be ignored for this round of work. This will be a stepping stone towards future postal codes integration, with an accent on geometries and biasing results towards centroids of postal codes.


## Infrastructure

### [OSS Community](/milestones/community_building/)
This is an ongoing goal that we plan to act on during every quarter, so don't be surprised to see it 
repeated every quarter.

### Revisit fastly caching configuration
>_Note: this milestone is a carry-over from Q3-2016_

### Improve installation and build process
>_Note: this milestone is a carry-over from Q3-2016_

Our vagrant build has fallen behind and is now broken, while many users still attempt to use it 
to setup a local installation of Pelias. We need to either fix vagrant or build a new system that will
allow local setup of Pelias.

### Make index snapshots publicly available
>_Note: this milestone is a carry-over from Q3-2016_
